#ifndef LATTE_ABSYN_HEADER
#define LATTE_ABSYN_HEADER

#include<string>
#include<memory>
#include<vector>
#include<latte/common/RelOp.h>
#include<latte/common/AddOp.h>
#include<latte/common/MulOp.h>

namespace Common {
class Type;
class Const;
}

namespace Backend {
class IRVar;
}

//C++ Abstract Syntax Interface generated by the BNF Converter.
namespace Latte
{
/********************   TypeDef Section    ********************/

typedef int Integer;
typedef char Char;
typedef double Double;
typedef std::string String;
typedef std::string Ident;




/********************   Forward Declarations    ********************/

class IdentP;
class Program;
class TopDef;
class FunDef;
class Arg;
class ClassDef;
class ClassBlock;
class ClassBlockDef;
class ClsFldDefItem;
class Block;
class Stmt;
class DeclItem;
class ClassType;
class BasicType;
class NonVoidType;
class Type;
class CastOn;
class Expr;
class AddOp;
class MulOp;
class RelOp;
class IdentPos;
class Prog;
class ClsDefTop;
class FnDefTop;
class FnDef;
class Ar;
class ClsDef;
class ClsExtDef;
class ClsBlk;
class ClsMthDef;
class ClsFldDef;
class ClsFldDefIt;
class Blk;
class Decl;
class NoInit;
class Init;
class Assign;
class Incr;
class Decr;
class Ret;
class VRet;
class While;
class For;
class If;
class IfElse;
class BStmt;
class Empty;
class Exp;
class TClass;
class TInt;
class TStr;
class TBool;
class TNVC;
class TNVB;
class TArray;
class TSingle;
class TVoid;
class CastOnClass;
class CastOnArr;
class CastOnBasic;
class ENewArr;
class ENewCls;
class ELitInt;
class ELitTrue;
class ELitFalse;
class EString;
class EVar;
class ENull;
class EMemb;
class EFunCall;
class EMembCall;
class EAt;
class ECast;
class Neg;
class Not;
class EMul;
class EAdd;
class ERel;
class EAnd;
class EOr;
class Plus;
class Minus;
class Times;
class Div;
class Mod;
class LTH;
class LE;
class GTH;
class GE;
class EQU;
class NE;
class ListTopDef;
class ListArg;
class ListClsFldDefItem;
class ListClassBlockDef;
class ListStmt;
class ListDeclItem;
class ListExpr;


/********************   Visitor Interfaces    ********************/
class Visitor
{
public:
  virtual ~Visitor() {}
  virtual void visitIdentP(IdentP *p) = 0;
  virtual void visitProgram(Program *p) = 0;
  virtual void visitTopDef(TopDef *p) = 0;
  virtual void visitFunDef(FunDef *p) = 0;
  virtual void visitArg(Arg *p) = 0;
  virtual void visitClassDef(ClassDef *p) = 0;
  virtual void visitClassBlock(ClassBlock *p) = 0;
  virtual void visitClassBlockDef(ClassBlockDef *p) = 0;
  virtual void visitClsFldDefItem(ClsFldDefItem *p) = 0;
  virtual void visitBlock(Block *p) = 0;
  virtual void visitStmt(Stmt *p) = 0;
  virtual void visitDeclItem(DeclItem *p) = 0;
  virtual void visitClassType(ClassType *p) = 0;
  virtual void visitBasicType(BasicType *p) = 0;
  virtual void visitNonVoidType(NonVoidType *p) = 0;
  virtual void visitType(Type *p) = 0;
  virtual void visitCastOn(CastOn *p) = 0;
  virtual void visitExpr(Expr *p) = 0;
  virtual void visitAddOp(AddOp *p) = 0;
  virtual void visitMulOp(MulOp *p) = 0;
  virtual void visitRelOp(RelOp *p) = 0;
  virtual void visitIdentPos(IdentPos *p) = 0;
  virtual void visitProg(Prog *p) = 0;
  virtual void visitClsDefTop(ClsDefTop *p) = 0;
  virtual void visitFnDefTop(FnDefTop *p) = 0;
  virtual void visitFnDef(FnDef *p) = 0;
  virtual void visitAr(Ar *p) = 0;
  virtual void visitClsDef(ClsDef *p) = 0;
  virtual void visitClsExtDef(ClsExtDef *p) = 0;
  virtual void visitClsBlk(ClsBlk *p) = 0;
  virtual void visitClsMthDef(ClsMthDef *p) = 0;
  virtual void visitClsFldDef(ClsFldDef *p) = 0;
  virtual void visitClsFldDefIt(ClsFldDefIt *p) = 0;
  virtual void visitBlk(Blk *p) = 0;
  virtual void visitDecl(Decl *p) = 0;
  virtual void visitNoInit(NoInit *p) = 0;
  virtual void visitInit(Init *p) = 0;
  virtual void visitAssign(Assign *p) = 0;
  virtual void visitIncr(Incr *p) = 0;
  virtual void visitDecr(Decr *p) = 0;
  virtual void visitRet(Ret *p) = 0;
  virtual void visitVRet(VRet *p) = 0;
  virtual void visitWhile(While *p) = 0;
  virtual void visitFor(For *p) = 0;
  virtual void visitIf(If *p) = 0;
  virtual void visitIfElse(IfElse *p) = 0;
  virtual void visitBStmt(BStmt *p) = 0;
  virtual void visitEmpty(Empty *p) = 0;
  virtual void visitExp(Exp *p) = 0;
  virtual void visitTClass(TClass *p) = 0;
  virtual void visitTInt(TInt *p) = 0;
  virtual void visitTStr(TStr *p) = 0;
  virtual void visitTBool(TBool *p) = 0;
  virtual void visitTNVC(TNVC *p) = 0;
  virtual void visitTNVB(TNVB *p) = 0;
  virtual void visitTArray(TArray *p) = 0;
  virtual void visitTSingle(TSingle *p) = 0;
  virtual void visitTVoid(TVoid *p) = 0;
  virtual void visitCastOnClass(CastOnClass *p) = 0;
  virtual void visitCastOnArr(CastOnArr *p) = 0;
  virtual void visitCastOnBasic(CastOnBasic *p) = 0;
  virtual void visitENewArr(ENewArr *p) = 0;
  virtual void visitENewCls(ENewCls *p) = 0;
  virtual void visitELitInt(ELitInt *p) = 0;
  virtual void visitELitTrue(ELitTrue *p) = 0;
  virtual void visitELitFalse(ELitFalse *p) = 0;
  virtual void visitEString(EString *p) = 0;
  virtual void visitEVar(EVar *p) = 0;
  virtual void visitENull(ENull *p) = 0;
  virtual void visitEMemb(EMemb *p) = 0;
  virtual void visitEFunCall(EFunCall *p) = 0;
  virtual void visitEMembCall(EMembCall *p) = 0;
  virtual void visitEAt(EAt *p) = 0;
  virtual void visitECast(ECast *p) = 0;
  virtual void visitNeg(Neg *p) = 0;
  virtual void visitNot(Not *p) = 0;
  virtual void visitEMul(EMul *p) = 0;
  virtual void visitEAdd(EAdd *p) = 0;
  virtual void visitERel(ERel *p) = 0;
  virtual void visitEAnd(EAnd *p) = 0;
  virtual void visitEOr(EOr *p) = 0;
  virtual void visitPlus(Plus *p) = 0;
  virtual void visitMinus(Minus *p) = 0;
  virtual void visitTimes(Times *p) = 0;
  virtual void visitDiv(Div *p) = 0;
  virtual void visitMod(Mod *p) = 0;
  virtual void visitLTH(LTH *p) = 0;
  virtual void visitLE(LE *p) = 0;
  virtual void visitGTH(GTH *p) = 0;
  virtual void visitGE(GE *p) = 0;
  virtual void visitEQU(EQU *p) = 0;
  virtual void visitNE(NE *p) = 0;
  virtual void visitListTopDef(ListTopDef *p) = 0;
  virtual void visitListArg(ListArg *p) = 0;
  virtual void visitListClsFldDefItem(ListClsFldDefItem *p) = 0;
  virtual void visitListClassBlockDef(ListClassBlockDef *p) = 0;
  virtual void visitListStmt(ListStmt *p) = 0;
  virtual void visitListDeclItem(ListDeclItem *p) = 0;
  virtual void visitListExpr(ListExpr *p) = 0;


  virtual void visitInteger(Integer x) = 0;
  virtual void visitChar(Char x) = 0;
  virtual void visitDouble(Double x) = 0;
  virtual void visitString(String x) = 0;
  virtual void visitIdent(Ident x) = 0;

};


class Visitable
{
 public:
  virtual ~Visitable() {}
  virtual void accept(Visitor *v) = 0;
};


/********************   Abstract Syntax Classes    ********************/

class IdentP : public Visitable
{
public:
  virtual IdentP *clone() const = 0;
  int line_number;
};

class Program : public Visitable
{
public:
  virtual Program *clone() const = 0;
  int line_number;
};

class TopDef : public Visitable
{
public:
  virtual TopDef *clone() const = 0;
  int line_number;
};

class FunDef : public Visitable
{
public:
  virtual FunDef *clone() const = 0;
  int line_number;
};

class Arg : public Visitable
{
public:
  virtual Arg *clone() const = 0;
  int line_number;
};

class ClassDef : public Visitable
{
public:
  virtual ClassDef *clone() const = 0;
  int line_number;
};

class ClassBlock : public Visitable
{
public:
  virtual ClassBlock *clone() const = 0;
  int line_number;
};

class ClassBlockDef : public Visitable
{
public:
  virtual ClassBlockDef *clone() const = 0;
  int line_number;
};

class ClsFldDefItem : public Visitable
{
public:
  virtual ClsFldDefItem *clone() const = 0;
  int line_number;
};

class Block : public Visitable
{
public:
  virtual Block *clone() const = 0;
  int line_number;
};

class Stmt : public Visitable
{
public:
  virtual Stmt *clone() const = 0;
  int line_number;
};

class DeclItem : public Visitable
{
public:
  virtual DeclItem *clone() const = 0;
  int line_number;
};

class ClassType : public Visitable
{
public:
  virtual ClassType *clone() const = 0;
  int line_number;
};

class BasicType : public Visitable
{
public:
  virtual BasicType *clone() const = 0;
  int line_number;
};

class NonVoidType : public Visitable
{
public:
  virtual NonVoidType *clone() const = 0;
  int line_number;
};

class Type : public Visitable
{
public:
  virtual Type *clone() const = 0;
  int line_number;
};

class CastOn : public Visitable
{
public:
  virtual CastOn *clone() const = 0;
  int line_number;
};

class Expr : public Visitable
{
public:
  virtual Expr *clone() const = 0;
  int line_number;

  // Added by JL
  bool ok;
  bool isConst;
  bool isLVal;
  std::shared_ptr<Common::Type> type;
  std::shared_ptr<Common::Const> const_;
  std::shared_ptr<Backend::IRVar> var;
};

class AddOp : public Visitable
{
public:
  virtual AddOp *clone() const = 0;
  int line_number;

  Common::addop_t op;
};

class MulOp : public Visitable
{
public:
  virtual MulOp *clone() const = 0;
  int line_number;
  Common::mulop_t op;
};


class RelOp : public Visitable
{
public:
  virtual RelOp *clone() const = 0;
  int line_number;

  Common::relop_t op;
};



class IdentPos : public IdentP
{
public:
  Ident ident_;

  IdentPos(const IdentPos &);
  IdentPos &operator=(const IdentPos &);
  IdentPos(Ident p1);
  ~IdentPos();
  virtual void accept(Visitor *v);
  virtual IdentPos *clone() const;
  void swap(IdentPos &);
};

class Prog : public Program
{
public:
  ListTopDef *listtopdef_;

  Prog(const Prog &);
  Prog &operator=(const Prog &);
  Prog(ListTopDef *p1);
  ~Prog();
  virtual void accept(Visitor *v);
  virtual Prog *clone() const;
  void swap(Prog &);
};

class ClsDefTop : public TopDef
{
public:
  ClassDef *classdef_;

  ClsDefTop(const ClsDefTop &);
  ClsDefTop &operator=(const ClsDefTop &);
  ClsDefTop(ClassDef *p1);
  ~ClsDefTop();
  virtual void accept(Visitor *v);
  virtual ClsDefTop *clone() const;
  void swap(ClsDefTop &);
};

class FnDefTop : public TopDef
{
public:
  FunDef *fundef_;

  FnDefTop(const FnDefTop &);
  FnDefTop &operator=(const FnDefTop &);
  FnDefTop(FunDef *p1);
  ~FnDefTop();
  virtual void accept(Visitor *v);
  virtual FnDefTop *clone() const;
  void swap(FnDefTop &);
};

class FnDef : public FunDef
{
public:
  Type *type_;
  IdentP *identp_;
  ListArg *listarg_;
  Block *block_;

  FnDef(const FnDef &);
  FnDef &operator=(const FnDef &);
  FnDef(Type *p1, IdentP *p2, ListArg *p3, Block *p4);
  ~FnDef();
  virtual void accept(Visitor *v);
  virtual FnDef *clone() const;
  void swap(FnDef &);
};

class Ar : public Arg
{
public:
  Type *type_;
  IdentP *identp_;

  Ar(const Ar &);
  Ar &operator=(const Ar &);
  Ar(Type *p1, IdentP *p2);
  ~Ar();
  virtual void accept(Visitor *v);
  virtual Ar *clone() const;
  void swap(Ar &);
};

class ClsDef : public ClassDef
{
public:
  IdentP *identp_;
  ClassBlock *classblock_;

  ClsDef(const ClsDef &);
  ClsDef &operator=(const ClsDef &);
  ClsDef(IdentP *p1, ClassBlock *p2);
  ~ClsDef();
  virtual void accept(Visitor *v);
  virtual ClsDef *clone() const;
  void swap(ClsDef &);
};

class ClsExtDef : public ClassDef
{
public:
  IdentP *identp_;
  Ident ident_;
  ClassBlock *classblock_;

  ClsExtDef(const ClsExtDef &);
  ClsExtDef &operator=(const ClsExtDef &);
  ClsExtDef(IdentP *p1, Ident p2, ClassBlock *p3);
  ~ClsExtDef();
  virtual void accept(Visitor *v);
  virtual ClsExtDef *clone() const;
  void swap(ClsExtDef &);
};

class ClsBlk : public ClassBlock
{
public:
  ListClassBlockDef *listclassblockdef_;

  ClsBlk(const ClsBlk &);
  ClsBlk &operator=(const ClsBlk &);
  ClsBlk(ListClassBlockDef *p1);
  ~ClsBlk();
  virtual void accept(Visitor *v);
  virtual ClsBlk *clone() const;
  void swap(ClsBlk &);
};

class ClsMthDef : public ClassBlockDef
{
public:
  FunDef *fundef_;

  ClsMthDef(const ClsMthDef &);
  ClsMthDef &operator=(const ClsMthDef &);
  ClsMthDef(FunDef *p1);
  ~ClsMthDef();
  virtual void accept(Visitor *v);
  virtual ClsMthDef *clone() const;
  void swap(ClsMthDef &);
};

class ClsFldDef : public ClassBlockDef
{
public:
  Type *type_;
  ListClsFldDefItem *listclsflddefitem_;

  ClsFldDef(const ClsFldDef &);
  ClsFldDef &operator=(const ClsFldDef &);
  ClsFldDef(Type *p1, ListClsFldDefItem *p2);
  ~ClsFldDef();
  virtual void accept(Visitor *v);
  virtual ClsFldDef *clone() const;
  void swap(ClsFldDef &);
};

class ClsFldDefIt : public ClsFldDefItem
{
public:
  IdentP *identp_;

  ClsFldDefIt(const ClsFldDefIt &);
  ClsFldDefIt &operator=(const ClsFldDefIt &);
  ClsFldDefIt(IdentP *p1);
  ~ClsFldDefIt();
  virtual void accept(Visitor *v);
  virtual ClsFldDefIt *clone() const;
  void swap(ClsFldDefIt &);
};

class Blk : public Block
{
public:
  ListStmt *liststmt_;

  Blk(const Blk &);
  Blk &operator=(const Blk &);
  Blk(ListStmt *p1);
  ~Blk();
  virtual void accept(Visitor *v);
  virtual Blk *clone() const;
  void swap(Blk &);
};

class Decl : public Stmt
{
public:
  Type *type_;
  ListDeclItem *listdeclitem_;

  Decl(const Decl &);
  Decl &operator=(const Decl &);
  Decl(Type *p1, ListDeclItem *p2);
  ~Decl();
  virtual void accept(Visitor *v);
  virtual Decl *clone() const;
  void swap(Decl &);
};

class Assign : public Stmt
{
public:
  Expr *expr_1;
  Expr *expr_2;

  Assign(const Assign &);
  Assign &operator=(const Assign &);
  Assign(Expr *p1, Expr *p2);
  ~Assign();
  virtual void accept(Visitor *v);
  virtual Assign *clone() const;
  void swap(Assign &);
};

class Incr : public Stmt
{
public:
  Expr *expr_;

  Incr(const Incr &);
  Incr &operator=(const Incr &);
  Incr(Expr *p1);
  ~Incr();
  virtual void accept(Visitor *v);
  virtual Incr *clone() const;
  void swap(Incr &);
};

class Decr : public Stmt
{
public:
  Expr *expr_;

  Decr(const Decr &);
  Decr &operator=(const Decr &);
  Decr(Expr *p1);
  ~Decr();
  virtual void accept(Visitor *v);
  virtual Decr *clone() const;
  void swap(Decr &);
};

class Ret : public Stmt
{
public:
  Expr *expr_;

  Ret(const Ret &);
  Ret &operator=(const Ret &);
  Ret(Expr *p1);
  ~Ret();
  virtual void accept(Visitor *v);
  virtual Ret *clone() const;
  void swap(Ret &);
};

class VRet : public Stmt
{
public:

  VRet(const VRet &);
  VRet &operator=(const VRet &);
  VRet();
  ~VRet();
  virtual void accept(Visitor *v);
  virtual VRet *clone() const;
  void swap(VRet &);
};

class While : public Stmt
{
public:
  Expr *expr_;
  Stmt *stmt_;

  While(const While &);
  While &operator=(const While &);
  While(Expr *p1, Stmt *p2);
  ~While();
  virtual void accept(Visitor *v);
  virtual While *clone() const;
  void swap(While &);
};

class For : public Stmt
{
public:
  Type *type_;
  Ident ident_;
  Expr *expr_;
  Stmt *stmt_;

  For(const For &);
  For &operator=(const For &);
  For(Type *p1, Ident p2, Expr *p3, Stmt *p4);
  ~For();
  virtual void accept(Visitor *v);
  virtual For *clone() const;
  void swap(For &);
};

class If : public Stmt
{
public:
  Expr *expr_;
  Stmt *stmt_;

  If(const If &);
  If &operator=(const If &);
  If(Expr *p1, Stmt *p2);
  ~If();
  virtual void accept(Visitor *v);
  virtual If *clone() const;
  void swap(If &);
};

class IfElse : public Stmt
{
public:
  Expr *expr_;
  Stmt *stmt_1;
  Stmt *stmt_2;

  IfElse(const IfElse &);
  IfElse &operator=(const IfElse &);
  IfElse(Expr *p1, Stmt *p2, Stmt *p3);
  ~IfElse();
  virtual void accept(Visitor *v);
  virtual IfElse *clone() const;
  void swap(IfElse &);
};

class BStmt : public Stmt
{
public:
  Block *block_;

  BStmt(const BStmt &);
  BStmt &operator=(const BStmt &);
  BStmt(Block *p1);
  ~BStmt();
  virtual void accept(Visitor *v);
  virtual BStmt *clone() const;
  void swap(BStmt &);
};

class Empty : public Stmt
{
public:

  Empty(const Empty &);
  Empty &operator=(const Empty &);
  Empty();
  ~Empty();
  virtual void accept(Visitor *v);
  virtual Empty *clone() const;
  void swap(Empty &);
};

class Exp : public Stmt
{
public:
  Expr *expr_;

  Exp(const Exp &);
  Exp &operator=(const Exp &);
  Exp(Expr *p1);
  ~Exp();
  virtual void accept(Visitor *v);
  virtual Exp *clone() const;
  void swap(Exp &);
};

class NoInit : public DeclItem
{
public:
  Ident ident_;

  NoInit(const NoInit &);
  NoInit &operator=(const NoInit &);
  NoInit(Ident p1);
  ~NoInit();
  virtual void accept(Visitor *v);
  virtual NoInit *clone() const;
  void swap(NoInit &);
};

class Init : public DeclItem
{
public:
  Ident ident_;
  Expr *expr_;

  Init(const Init &);
  Init &operator=(const Init &);
  Init(Ident p1, Expr *p2);
  ~Init();
  virtual void accept(Visitor *v);
  virtual Init *clone() const;
  void swap(Init &);
};

class TClass : public ClassType
{
public:
  Ident ident_;

  TClass(const TClass &);
  TClass &operator=(const TClass &);
  TClass(Ident p1);
  ~TClass();
  virtual void accept(Visitor *v);
  virtual TClass *clone() const;
  void swap(TClass &);
};

class TInt : public BasicType
{
public:

  TInt(const TInt &);
  TInt &operator=(const TInt &);
  TInt();
  ~TInt();
  virtual void accept(Visitor *v);
  virtual TInt *clone() const;
  void swap(TInt &);
};

class TStr : public BasicType
{
public:

  TStr(const TStr &);
  TStr &operator=(const TStr &);
  TStr();
  ~TStr();
  virtual void accept(Visitor *v);
  virtual TStr *clone() const;
  void swap(TStr &);
};

class TBool : public BasicType
{
public:

  TBool(const TBool &);
  TBool &operator=(const TBool &);
  TBool();
  ~TBool();
  virtual void accept(Visitor *v);
  virtual TBool *clone() const;
  void swap(TBool &);
};

class TNVC : public NonVoidType
{
public:
  ClassType *classtype_;

  TNVC(const TNVC &);
  TNVC &operator=(const TNVC &);
  TNVC(ClassType *p1);
  ~TNVC();
  virtual void accept(Visitor *v);
  virtual TNVC *clone() const;
  void swap(TNVC &);
};

class TNVB : public NonVoidType
{
public:
  BasicType *basictype_;

  TNVB(const TNVB &);
  TNVB &operator=(const TNVB &);
  TNVB(BasicType *p1);
  ~TNVB();
  virtual void accept(Visitor *v);
  virtual TNVB *clone() const;
  void swap(TNVB &);
};

class TArray : public Type
{
public:
  NonVoidType *nonvoidtype_;

  TArray(const TArray &);
  TArray &operator=(const TArray &);
  TArray(NonVoidType *p1);
  ~TArray();
  virtual void accept(Visitor *v);
  virtual TArray *clone() const;
  void swap(TArray &);
};

class TSingle : public Type
{
public:
  NonVoidType *nonvoidtype_;

  TSingle(const TSingle &);
  TSingle &operator=(const TSingle &);
  TSingle(NonVoidType *p1);
  ~TSingle();
  virtual void accept(Visitor *v);
  virtual TSingle *clone() const;
  void swap(TSingle &);
};

class TVoid : public Type
{
public:

  TVoid(const TVoid &);
  TVoid &operator=(const TVoid &);
  TVoid();
  ~TVoid();
  virtual void accept(Visitor *v);
  virtual TVoid *clone() const;
  void swap(TVoid &);
};

class CastOnClass : public CastOn
{
public:
  Ident ident_;

  CastOnClass(const CastOnClass &);
  CastOnClass &operator=(const CastOnClass &);
  CastOnClass(Ident p1);
  ~CastOnClass();
  virtual void accept(Visitor *v);
  virtual CastOnClass *clone() const;
  void swap(CastOnClass &);
};

class CastOnArr : public CastOn
{
public:
  NonVoidType *nonvoidtype_;

  CastOnArr(const CastOnArr &);
  CastOnArr &operator=(const CastOnArr &);
  CastOnArr(NonVoidType *p1);
  ~CastOnArr();
  virtual void accept(Visitor *v);
  virtual CastOnArr *clone() const;
  void swap(CastOnArr &);
};

class CastOnBasic : public CastOn
{
public:
  BasicType *basictype_;

  CastOnBasic(const CastOnBasic &);
  CastOnBasic &operator=(const CastOnBasic &);
  CastOnBasic(BasicType *p1);
  ~CastOnBasic();
  virtual void accept(Visitor *v);
  virtual CastOnBasic *clone() const;
  void swap(CastOnBasic &);
};

class ENewArr : public Expr
{
public:
  NonVoidType *nonvoidtype_;
  Expr *expr_;

  ENewArr(const ENewArr &);
  ENewArr &operator=(const ENewArr &);
  ENewArr(NonVoidType *p1, Expr *p2);
  ~ENewArr();
  virtual void accept(Visitor *v);
  virtual ENewArr *clone() const;
  void swap(ENewArr &);
};

class ENewCls : public Expr
{
public:
  Ident ident_;

  ENewCls(const ENewCls &);
  ENewCls &operator=(const ENewCls &);
  ENewCls(Ident p1);
  ~ENewCls();
  virtual void accept(Visitor *v);
  virtual ENewCls *clone() const;
  void swap(ENewCls &);
};

class ELitInt : public Expr
{
public:
  Integer integer_;

  ELitInt(const ELitInt &);
  ELitInt &operator=(const ELitInt &);
  ELitInt(Integer p1);
  ~ELitInt();
  virtual void accept(Visitor *v);
  virtual ELitInt *clone() const;
  void swap(ELitInt &);
};

class ELitTrue : public Expr
{
public:

  ELitTrue(const ELitTrue &);
  ELitTrue &operator=(const ELitTrue &);
  ELitTrue();
  ~ELitTrue();
  virtual void accept(Visitor *v);
  virtual ELitTrue *clone() const;
  void swap(ELitTrue &);
};

class ELitFalse : public Expr
{
public:

  ELitFalse(const ELitFalse &);
  ELitFalse &operator=(const ELitFalse &);
  ELitFalse();
  ~ELitFalse();
  virtual void accept(Visitor *v);
  virtual ELitFalse *clone() const;
  void swap(ELitFalse &);
};

class EString : public Expr
{
public:
  String string_;

  EString(const EString &);
  EString &operator=(const EString &);
  EString(String p1);
  ~EString();
  virtual void accept(Visitor *v);
  virtual EString *clone() const;
  void swap(EString &);
};

class EVar : public Expr
{
public:
  Ident ident_;
  std::string var_label;

  EVar(const EVar &);
  EVar &operator=(const EVar &);
  EVar(Ident p1);
  ~EVar();
  virtual void accept(Visitor *v);
  virtual EVar *clone() const;
  void swap(EVar &);
};

class ENull : public Expr
{
public:

  ENull(const ENull &);
  ENull &operator=(const ENull &);
  ENull();
  ~ENull();
  virtual void accept(Visitor *v);
  virtual ENull *clone() const;
  void swap(ENull &);
};

class EMemb : public Expr
{
public:
  Expr *expr_;
  Ident ident_;

  EMemb(const EMemb &);
  EMemb &operator=(const EMemb &);
  EMemb(Expr *p1, Ident p2);
  ~EMemb();
  virtual void accept(Visitor *v);
  virtual EMemb *clone() const;
  void swap(EMemb &);
};

class EFunCall : public Expr
{
public:
  Ident ident_;
  ListExpr *listexpr_;

  EFunCall(const EFunCall &);
  EFunCall &operator=(const EFunCall &);
  EFunCall(Ident p1, ListExpr *p2);
  ~EFunCall();
  virtual void accept(Visitor *v);
  virtual EFunCall *clone() const;
  void swap(EFunCall &);
};

class EMembCall : public Expr
{
public:
  Expr *expr_;
  Ident ident_;
  ListExpr *listexpr_;

  EMembCall(const EMembCall &);
  EMembCall &operator=(const EMembCall &);
  EMembCall(Expr *p1, Ident p2, ListExpr *p3);
  ~EMembCall();
  virtual void accept(Visitor *v);
  virtual EMembCall *clone() const;
  void swap(EMembCall &);
};

class EAt : public Expr
{
public:
  Expr *expr_1;
  Expr *expr_2;

  EAt(const EAt &);
  EAt &operator=(const EAt &);
  EAt(Expr *p1, Expr *p2);
  ~EAt();
  virtual void accept(Visitor *v);
  virtual EAt *clone() const;
  void swap(EAt &);
};

class ECast : public Expr
{
public:
  CastOn *caston_;
  Expr *expr_;

  ECast(const ECast &);
  ECast &operator=(const ECast &);
  ECast(CastOn *p1, Expr *p2);
  ~ECast();
  virtual void accept(Visitor *v);
  virtual ECast *clone() const;
  void swap(ECast &);
};

class Neg : public Expr
{
public:
  Expr *expr_;

  Neg(const Neg &);
  Neg &operator=(const Neg &);
  Neg(Expr *p1);
  ~Neg();
  virtual void accept(Visitor *v);
  virtual Neg *clone() const;
  void swap(Neg &);
};

class Not : public Expr
{
public:
  Expr *expr_;

  Not(const Not &);
  Not &operator=(const Not &);
  Not(Expr *p1);
  ~Not();
  virtual void accept(Visitor *v);
  virtual Not *clone() const;
  void swap(Not &);
};

class EMul : public Expr
{
public:
  Expr *expr_1;
  MulOp *mulop_;
  Expr *expr_2;

  EMul(const EMul &);
  EMul &operator=(const EMul &);
  EMul(Expr *p1, MulOp *p2, Expr *p3);
  ~EMul();
  virtual void accept(Visitor *v);
  virtual EMul *clone() const;
  void swap(EMul &);
};

class EAdd : public Expr
{
public:
  Expr *expr_1;
  AddOp *addop_;
  Expr *expr_2;

  EAdd(const EAdd &);
  EAdd &operator=(const EAdd &);
  EAdd(Expr *p1, AddOp *p2, Expr *p3);
  ~EAdd();
  virtual void accept(Visitor *v);
  virtual EAdd *clone() const;
  void swap(EAdd &);
};

class ERel : public Expr
{
public:
  Expr *expr_1;
  RelOp *relop_;
  Expr *expr_2;

  ERel(const ERel &);
  ERel &operator=(const ERel &);
  ERel(Expr *p1, RelOp *p2, Expr *p3);
  ~ERel();
  virtual void accept(Visitor *v);
  virtual ERel *clone() const;
  void swap(ERel &);
};

class EAnd : public Expr
{
public:
  Expr *expr_1;
  Expr *expr_2;

  EAnd(const EAnd &);
  EAnd &operator=(const EAnd &);
  EAnd(Expr *p1, Expr *p2);
  ~EAnd();
  virtual void accept(Visitor *v);
  virtual EAnd *clone() const;
  void swap(EAnd &);
};

class EOr : public Expr
{
public:
  Expr *expr_1;
  Expr *expr_2;

  EOr(const EOr &);
  EOr &operator=(const EOr &);
  EOr(Expr *p1, Expr *p2);
  ~EOr();
  virtual void accept(Visitor *v);
  virtual EOr *clone() const;
  void swap(EOr &);
};

class Plus : public AddOp
{
public:

  Plus(const Plus &);
  Plus &operator=(const Plus &);
  Plus();
  ~Plus();
  virtual void accept(Visitor *v);
  virtual Plus *clone() const;
  void swap(Plus &);
};

class Minus : public AddOp
{
public:

  Minus(const Minus &);
  Minus &operator=(const Minus &);
  Minus();
  ~Minus();
  virtual void accept(Visitor *v);
  virtual Minus *clone() const;
  void swap(Minus &);
};

class Times : public MulOp
{
public:

  Times(const Times &);
  Times &operator=(const Times &);
  Times();
  ~Times();
  virtual void accept(Visitor *v);
  virtual Times *clone() const;
  void swap(Times &);
};

class Div : public MulOp
{
public:

  Div(const Div &);
  Div &operator=(const Div &);
  Div();
  ~Div();
  virtual void accept(Visitor *v);
  virtual Div *clone() const;
  void swap(Div &);
};

class Mod : public MulOp
{
public:

  Mod(const Mod &);
  Mod &operator=(const Mod &);
  Mod();
  ~Mod();
  virtual void accept(Visitor *v);
  virtual Mod *clone() const;
  void swap(Mod &);
};

class LTH : public RelOp
{
public:

  LTH(const LTH &);
  LTH &operator=(const LTH &);
  LTH();
  ~LTH();
  virtual void accept(Visitor *v);
  virtual LTH *clone() const;
  void swap(LTH &);
};

class LE : public RelOp
{
public:

  LE(const LE &);
  LE &operator=(const LE &);
  LE();
  ~LE();
  virtual void accept(Visitor *v);
  virtual LE *clone() const;
  void swap(LE &);
};

class GTH : public RelOp
{
public:

  GTH(const GTH &);
  GTH &operator=(const GTH &);
  GTH();
  ~GTH();
  virtual void accept(Visitor *v);
  virtual GTH *clone() const;
  void swap(GTH &);
};

class GE : public RelOp
{
public:

  GE(const GE &);
  GE &operator=(const GE &);
  GE();
  ~GE();
  virtual void accept(Visitor *v);
  virtual GE *clone() const;
  void swap(GE &);
};

class EQU : public RelOp
{
public:

  EQU(const EQU &);
  EQU &operator=(const EQU &);
  EQU();
  ~EQU();
  virtual void accept(Visitor *v);
  virtual EQU *clone() const;
  void swap(EQU &);
};

class NE : public RelOp
{
public:

  NE(const NE &);
  NE &operator=(const NE &);
  NE();
  ~NE();
  virtual void accept(Visitor *v);
  virtual NE *clone() const;
  void swap(NE &);
};



class ListTopDef : public Visitable, public std::vector<TopDef*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListTopDef *clone() const;
};

class ListArg : public Visitable, public std::vector<Arg*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListArg *clone() const;
};

class ListClsFldDefItem : public Visitable, public std::vector<ClsFldDefItem*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListClsFldDefItem *clone() const;
};

class ListClassBlockDef : public Visitable, public std::vector<ClassBlockDef*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListClassBlockDef *clone() const;
};

class ListStmt : public Visitable, public std::vector<Stmt*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListStmt *clone() const;
};

class ListDeclItem : public Visitable, public std::vector<DeclItem*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListDeclItem *clone() const;
};

class ListExpr : public Visitable, public std::vector<Expr*>
{
public:
  virtual void accept(Visitor *v);
  virtual ListExpr *clone() const;
};


}
#endif
